var yesButton = $("<button/>").attr("type", "button").addClass("col-xs-4 button btn button-yellow")
    .append(yesMessage).attr("data-dismiss", "modal");
var noButton = $("<button/>").attr("type", "button").addClass("col-xs-4 button btn button-yellow pull-right").append(noMessage).attr("data-dismiss", "modal");;
var yesNoFooter = $("<div/>").addClass("content-row").append(yesButton).append(noButton);
var emergencyStatus = $("#emergency-status-ventilation");
var emergencyButton = $("#emergency-ventilation");

$(document).ready(function () {
    
    
    $(".operation-mode-status").on('change', function() {
        var currElement = this;
        var buttons = $(currElement).parent().find(".start-stop");
        var rawStatus = $(currElement).siblings(".raw-status");
        var value = $(currElement).val();
        if (value == 0) {
            $(buttons).attr('disabled', 'disabled');
        } else {
            $(buttons).removeAttr('disabled');
            $(rawStatus).trigger("change");
        }
        
    });

    $(".raw-status").on('change', function() {
        var currElement = this;
        console.log("Changed raw status");
        var operationStatusMode = $(currElement).siblings(".operation-mode-status").val();
        if (operationStatusMode == 1) {
            console.log("I can change buttons");
            var startButton = $(currElement).parent().find(".start-button");
            var stopButton = $(currElement).parent().find(".stop-button");
            console.log(startButton);
            console.log(stopButton);
            if ($(currElement).val() == 0) {
                $(stopButton).attr('disabled', true);
                $(startButton).removeAttr('disabled');
            } else {
                $(startButton).attr('disabled', true);
                $(stopButton).removeAttr('disabled');
            }
        }
    });

    $(".start-stop").on('click', function() {
        var currButton = this;
        var confirmationMessage = $(currButton).attr('data-status') == "off" ? offMessage: onMessage;
        var previousFooter = $("#status-modal-footer").html();
        $("#status-modal").on('show.bs.modal.status', function() {
            
            $("#status-modal-title").text(confirmationMessage);
            $("#status-modal-footer").html($(yesNoFooter));
            $(yesButton).on('click', function() {statusChange(currButton)});
            $(noButton).on('click', function() {consoleNo(currButton, previousFooter)});
            $(this).unbind('show.bs.modal.status');
        });

        $("#status-modal").on('hide.bs.modal.status', function() {
            $(yesButton).unbind('click');
            $(noButton).unbind('click');
            closeModal(previousFooter);
            $(this).unbind('hide.bs.modal.status');
        });
        $("#status-modal").modal("show");

        
    });

    $("#emergency-ventilation").on('click', function () {
        var currButton = this;
        var confirmationMessage = $(emergencyStatus).val() == 1? normalVentilationMessage : emergencyVentilationMessage;
        var previousFooter = $("#status-modal-footer").html();
        $("#status-modal").on('show.bs.modal.emergency', function () {
            $("#status-modal-title").text(confirmationMessage);
            $("#status-modal-body").text(areYouSure);
            $("#status-modal-footer").html($(yesNoFooter));
            $(yesButton).on('click', function() {sendEmergency()});
            $(this).unbind('show.bs.modal.emergency');

        });

        $("#status-modal").on('hide.bs.modal.emergency', function() {
            $(yesButton).unbind('click');
            $(noButton).unbind('click');
            closeModal(previousFooter);
            $(this).unbind('hide.bs.modal.emergency');
        });

        $("#status-modal").modal("show");

    });


    $(emergencyStatus).on('change', function () {
        
        var buttonMessage =  $(emergencyStatus).val() == 0 ? initiateEmergencyVentilation : returnNormalVentilation;
        
        $("#emergency-ventilation").text(buttonMessage);
    });
});


function statusChange(currButton) {
    var buttons = $(currButton).parent().parent().find(".start-stop");
    console.log(buttons);
    $(buttons).removeAttr('disabled');
    $(currButton).attr('disabled', true);
    var status = $(currButton).attr('data-status-address');
    var data = {
        type: 'write',
        values: [
            {
                name:"status",
                address:status
            }
        ]  
        
    };
    wsWrite(data);
    
}

function sendEmergency() {
    var newStatus = $(emergencyStatus).val()  == 1 ? 0 : 1;
    var emergencyAddress = "3:32:0:0:"+newStatus;
    var data = {
        type: 'write',
        values: [
            {
                name:"status",
                address: emergencyAddress
            }
        ]  
        
    };
    wsWrite(data);
    


}

function consoleNo(previousFooter) {
    //closeModal(previousFooter);
}

function closeModal(previousFooter) {
    $("#status-modal-title").text('');
    $("#status-modal-body").html('');
    $("#status-modal-footer").html($(previousFooter));
}
